<template>
    <el-dialog :title="title" v-model="visible" width="60%"
               :close-on-click-modal="false" draggable>
        <el-form ref="dataFormRef" :model="form" :rules="dataRules" label-width="90px" v-loading="loading" :disabled="operType === 'view'">
            <el-row :gutter="24">

                <el-col :span="12" class="mb20">
                    <el-form-item :label="$t('jfcomment.flowInstId')" prop="flowInstId" >
                        <el-input v-model="form.flowInstId" :placeholder="t('jfcomment.inputFlowInstIdTip')" disabled/>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('jfcomment.flowKey')" prop="flowKey">
                        <el-select v-model="form.flowKey" :placeholder="t('jfcomment.inputFlowKeyTip')" clearable filterable disabled>
                            <el-option v-for="(item, index) in cascadeDic.flowKey" :key="index" :label="item.flowName" :value="item.flowKey"></el-option>
                        </el-select>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('jfcomment.runNodeId')" prop="runNodeId">
                        <el-select v-model="form.runNodeId" :placeholder="t('jfcomment.inputRunNodeIdTip')" clearable filterable disabled>
                            <el-option v-for="(item, index) in cascadeDic.runNodeId" :key="index" :label="item.nodeName" :value="item.id"></el-option>
                        </el-select>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('jfcomment.runJobId')" prop="runJobId">
                        <el-select v-model="form.runJobId" :placeholder="t('jfcomment.inputRunJobIdTip')" clearable filterable disabled>
                            <el-option v-for="(item, index) in cascadeDic.runJobId" :key="index" :label="item.jobName" :value="item.id"></el-option>
                        </el-select>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('jfcomment.userId')" prop="userId">
                        <el-select v-model="form.userId" :placeholder="t('jfcomment.inputUserIdTip')" clearable filterable>
                            <el-option v-for="(item, index) in dicData.userId" :key="index" :label="item.name" :value="item.userId"></el-option>
                        </el-select>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('jfcomment.remark')" prop="remark">
                        <el-input v-model="form.remark" type="textarea" :placeholder="t('jfcomment.inputRemarkTip')"/>
                    </el-form-item>
                </el-col>

            </el-row>
        </el-form>
        <template #footer v-if="operType !== 'view'">
        <span class="dialog-footer">
          <el-button @click="visible = false">{{ $t('common.cancelButtonText') }}</el-button>
          <el-button type="primary" @click="onSubmit" :disabled="loading">{{ $t('common.confirmButtonText') }}</el-button>
        </span>
        </template>
    </el-dialog>
</template>

<script setup lang="ts" name="CommentDialog">

    import { useMessage } from "/@/hooks/message";
    import { getObj, addObj, putObj } from '/@/api/jsonflow/comment'
    import { useI18n } from "vue-i18n"
    import { rule } from '/@/utils/validate';
    import {onCascadeChange, onLoadDicUrl} from "/@/flow/components/convert-name/convert";
    const emit = defineEmits(['refresh']);

    const { t } = useI18n();

    // 定义变量内容
    const dataFormRef = ref();
    const visible = ref(false);
    const loading = ref(false);
    const operType = ref(false);
    const title = ref('');
    // 定义字典
    const dicData = reactive({});
    const cascadeDic = reactive({});
    const onLoad = onLoadDicUrl({key: "userId"});
    const onCascade = onCascadeChange(cascadeDic, {key: "flowInstId", cascades: ["flowKey", "runNodeId"]}, {key: "runNodeId", cascades: ["runJobId"]});
    onMounted(() => {
        onLoad(dicData);
    });

    // 提交表单数据
    const form = reactive({
        flowKey: '',
        flowNodeId: '',
        nodeJobId: '',
        userId: '',
        remark: '',
    });

    // 定义校验规则
    const dataRules = ref({
        flowKey: [{required: true, message: '流程名称不能为空', trigger: 'blur'}],
        flowNodeId: [{required: true, message: '节点名称不能为空', trigger: 'blur'}],
        nodeJobId: [{required: true, message: '任务名称不能为空', trigger: 'blur'}],
        userId: [{required: true, message: '审批人不能为空', trigger: 'blur'}],
        remark: [{required: true, message: '审批意见不能为空', trigger: 'blur'}],
    })

    // 打开弹窗
    const openDialog = (type: string, id: string) => {
        visible.value = true
        operType.value = type;
        form.id = ''

        if (type === 'add') {
            title.value = t('common.addBtn');
        } else if (type === 'edit') {
            title.value = t('common.editBtn');
        } else if (type === 'view') {
            title.value = t('common.viewBtn');
        }

        // 重置表单数据
        nextTick(() => {
            dataFormRef.value?.resetFields();
        });

        // 获取Comment信息
        if (id) {
            form.id = id
            getCommentData(id)
        }
    };

    // 提交
    const onSubmit = async () => {
        const valid = await dataFormRef.value.validate().catch(() => {});
        if (!valid) return false;

        try {
            loading.value = true;
            form.id ? await putObj(form) : await addObj(form);
            useMessage().success(t(form.id ? 'common.editSuccessText' : 'common.addSuccessText'));
            visible.value = false;
            emit('refresh');
        } catch (err: any) {
            useMessage().error(err.msg);
        } finally {
            loading.value = false;
        }
    };

    // 初始化表单数据
    const getCommentData = (id: string) => {
        // 获取数据
        loading.value = true
        getObj(id).then((res: any) => {
            Object.assign(form, res.data)
            onCascade(form);
        }).finally(() => {
            loading.value = false
        })
    };

    // 暴露变量
    defineExpose({
        openDialog
    });
</script>
